<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TextMessageOutboxSelection_V2 StructType
 * @subpackage Structs
 */
class TextMessageOutboxSelection_V2 extends AbstractStructBase
{
    /**
     * The IncludeReplies
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeReplies;
    /**
     * The DateTimeRange
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRange;
    /**
     * The SelectionFromToday
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeAndIdSelection
     */
    public $SelectionFromToday;
    /**
     * The TextMessages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfLong
     */
    public $TextMessages;
    /**
     * The Vehicles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * Constructor method for TextMessageOutboxSelection_V2
     * @uses TextMessageOutboxSelection_V2::setIncludeReplies()
     * @uses TextMessageOutboxSelection_V2::setDateTimeRange()
     * @uses TextMessageOutboxSelection_V2::setSelectionFromToday()
     * @uses TextMessageOutboxSelection_V2::setTextMessages()
     * @uses TextMessageOutboxSelection_V2::setVehicles()
     * @param bool $includeReplies
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @param \StructType\DateTimeAndIdSelection $selectionFromToday
     * @param \ArrayType\ArrayOfLong $textMessages
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     */
    public function __construct($includeReplies = null, \StructType\DateTimeRangeSelection $dateTimeRange = null, \StructType\DateTimeAndIdSelection $selectionFromToday = null, \ArrayType\ArrayOfLong $textMessages = null, \ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this
            ->setIncludeReplies($includeReplies)
            ->setDateTimeRange($dateTimeRange)
            ->setSelectionFromToday($selectionFromToday)
            ->setTextMessages($textMessages)
            ->setVehicles($vehicles);
    }
    /**
     * Get IncludeReplies value
     * @return bool
     */
    public function getIncludeReplies()
    {
        return $this->IncludeReplies;
    }
    /**
     * Set IncludeReplies value
     * @param bool $includeReplies
     * @return \StructType\TextMessageOutboxSelection_V2
     */
    public function setIncludeReplies($includeReplies = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeReplies) && !is_bool($includeReplies)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeReplies, true), gettype($includeReplies)), __LINE__);
        }
        $this->IncludeReplies = $includeReplies;
        return $this;
    }
    /**
     * Get DateTimeRange value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRange()
    {
        return $this->DateTimeRange;
    }
    /**
     * Set DateTimeRange value
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @return \StructType\TextMessageOutboxSelection_V2
     */
    public function setDateTimeRange(\StructType\DateTimeRangeSelection $dateTimeRange = null)
    {
        $this->DateTimeRange = $dateTimeRange;
        return $this;
    }
    /**
     * Get SelectionFromToday value
     * @return \StructType\DateTimeAndIdSelection|null
     */
    public function getSelectionFromToday()
    {
        return $this->SelectionFromToday;
    }
    /**
     * Set SelectionFromToday value
     * @param \StructType\DateTimeAndIdSelection $selectionFromToday
     * @return \StructType\TextMessageOutboxSelection_V2
     */
    public function setSelectionFromToday(\StructType\DateTimeAndIdSelection $selectionFromToday = null)
    {
        $this->SelectionFromToday = $selectionFromToday;
        return $this;
    }
    /**
     * Get TextMessages value
     * @return \ArrayType\ArrayOfLong|null
     */
    public function getTextMessages()
    {
        return $this->TextMessages;
    }
    /**
     * Set TextMessages value
     * @param \ArrayType\ArrayOfLong $textMessages
     * @return \StructType\TextMessageOutboxSelection_V2
     */
    public function setTextMessages(\ArrayType\ArrayOfLong $textMessages = null)
    {
        $this->TextMessages = $textMessages;
        return $this;
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\TextMessageOutboxSelection_V2
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
}
